Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeILEmittingInterpreter.cs	(revision 18132)
@@ -711,9 +711,10 @@
             return;
           }
+        case OpCodes.Number: // fall through
         case OpCodes.Constant: {
-            ConstantTreeNode constNode = (ConstantTreeNode)currentInstr.dynamicNode;
-            il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, constNode.Value);
-            return;
-          }
+          var constNode = (INumericTreeNode) currentInstr.dynamicNode;
+          il.Emit(System.Reflection.Emit.OpCodes.Ldc_R8, constNode.Value);
+          return;
+        }
 
         //mkommend: this symbol uses the logistic function f(x) = 1 / (1 + e^(-alpha * x) ) 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeInterpreter.cs	(revision 18132)
@@ -496,8 +496,9 @@
             return ((IList<double>)currentInstr.data)[actualRow] * laggedVariableTreeNode.Weight;
           }
-        case OpCodes.Constant: {
-            var constTreeNode = (ConstantTreeNode)currentInstr.dynamicNode;
-            return constTreeNode.Value;
-          }
+        case OpCodes.Constant:  // fall through
+        case OpCodes.Number: {
+          var numericTreeNode = (INumericTreeNode) currentInstr.dynamicNode;
+          return numericTreeNode.Value;
+        }
 
         //mkommend: this symbol uses the logistic function f(x) = 1 / (1 + e^(-alpha * x) ) 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeLinearInterpreter.cs	(revision 18132)
@@ -416,8 +416,9 @@
         #region opcode switch
         switch (instr.opCode) {
+          case OpCodes.Number: // fall through
           case OpCodes.Constant: {
-              var constTreeNode = (ConstantTreeNode)instr.dynamicNode;
-              instr.value = constTreeNode.Value;
-              instr.skip = true; // the value is already set so this instruction should be skipped in the evaluation phase
+            var numericTreeNode = (INumericTreeNode)instr.dynamicNode;
+            instr.value = numericTreeNode.Value;
+            instr.skip = true; // the value is already set so this instruction should be skipped in the evaluation phase
             }
             break;
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Interpreter/SymbolicDataAnalysisExpressionTreeNativeInterpreter.cs	(revision 18132)
@@ -82,6 +82,6 @@
           code[i].weight = variable.Weight;
           code[i].data = cachedData[variable.VariableName].AddrOfPinnedObject();
-        } else if (node is ConstantTreeNode constant) {
-          code[i].value = constant.Value;
+        } else if (node is INumericTreeNode numeric) {
+          code[i].value = numeric.Value;
         }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisExpressionPruningOperator.cs	(revision 18132)
@@ -33,5 +33,5 @@
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
   [StorableType("DBE27385-2E8C-4314-88B4-F96A5240FC9D")]
-  [Item("SymbolicExpressionTreePruningOperator", "An operator that replaces introns with constant values in a symbolic expression tree.")]
+  [Item("SymbolicExpressionTreePruningOperator", "An operator that replaces sub-trees with small impacts with numbers in a symbolic expression tree.")]
   public abstract class SymbolicDataAnalysisExpressionPruningOperator : SingleSuccessorOperator, ISymbolicExpressionTreeOperator {
     #region parameter names
@@ -172,18 +172,17 @@
       for (int i = 0; i < nodes.Count; ++i) {
         var node = nodes[i];
-        if (node is ConstantTreeNode) continue;
-
-        double impactValue, replacementValue;
-        double newQualityForImpacts;
-        ImpactValuesCalculator.CalculateImpactAndReplacementValues(model, node, problemData, rows, out impactValue, out replacementValue, out newQualityForImpacts, qualityForImpactsCalculation);
+        if (node is INumericTreeNode) continue;
+
+        ImpactValuesCalculator.CalculateImpactAndReplacementValues(model, node, problemData, rows, 
+          out double impactValue, out double replacementValue, out double newQualityForImpacts, qualityForImpactsCalculation);
 
         if (PruneOnlyZeroImpactNodes && !impactValue.IsAlmost(0.0)) continue;
         if (!PruneOnlyZeroImpactNodes && impactValue > NodeImpactThreshold) continue;
 
-        var constantNode = (ConstantTreeNode)node.Grammar.GetSymbol("Constant").CreateTreeNode();
-        constantNode.Value = replacementValue;
+        var numberNode = (NumberTreeNode)node.Grammar.GetSymbol("Number").CreateTreeNode();
+        numberNode.Value = replacementValue;
 
         var length = node.GetLength();
-        ReplaceWithConstant(node, constantNode);
+        ReplaceWithNumber(node, numberNode);
         i += length - 1; // skip subtrees under the node that was folded
 
@@ -205,5 +204,5 @@
     }
 
-    protected static void ReplaceWithConstant(ISymbolicExpressionTreeNode original, ISymbolicExpressionTreeNode replacement) {
+    protected static void ReplaceWithNumber(ISymbolicExpressionTreeNode original, ISymbolicExpressionTreeNode replacement) {
       var parent = original.Parent;
       var i = parent.IndexOfSubtree(original);
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModel.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModel.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModel.cs	(revision 18132)
@@ -115,14 +115,14 @@
       if (linearScalingCalculator.ErrorState != OnlineCalculatorError.None) return;
 
-      ConstantTreeNode alphaTreeNode = null;
-      ConstantTreeNode betaTreeNode = null;
+      NumberTreeNode alphaTreeNode = null;
+      NumberTreeNode betaTreeNode = null;
       // check if model has a structure that can be re-used for scaling
       var startNode = SymbolicExpressionTree.Root.GetSubtree(0);
       var addNode = startNode.GetSubtree(0);
       if (addNode.Symbol is Addition && addNode.SubtreeCount == 2) {
-        alphaTreeNode = (ConstantTreeNode)addNode.Subtrees.LastOrDefault(n => n is ConstantTreeNode);
+        alphaTreeNode = (NumberTreeNode)addNode.Subtrees.LastOrDefault(n => n is NumberTreeNode);
         var mulNode = addNode.Subtrees.FirstOrDefault(n => n.Symbol is Multiplication);
         if (mulNode != null) {
-          betaTreeNode = (ConstantTreeNode)mulNode.Subtrees.LastOrDefault(n => n is ConstantTreeNode);
+          betaTreeNode = (NumberTreeNode)mulNode.Subtrees.LastOrDefault(n => n is NumberTreeNode);
         }
       }
@@ -146,7 +146,7 @@
         var addition = new Addition();
         var node = addition.CreateTreeNode();
-        var alphaConst = MakeConstant(alpha);
+        var alphaNode = MakeNumber(alpha);
         node.AddSubtree(treeNode);
-        node.AddSubtree(alphaConst);
+        node.AddSubtree(alphaNode);
         return node;
       }
@@ -157,15 +157,15 @@
         return treeNode;
       } else {
-        var multipliciation = new Multiplication();
-        var node = multipliciation.CreateTreeNode();
-        var betaConst = MakeConstant(beta);
+        var multiplication = new Multiplication();
+        var node = multiplication.CreateTreeNode();
+        var betaNode = MakeNumber(beta);
         node.AddSubtree(treeNode);
-        node.AddSubtree(betaConst);
+        node.AddSubtree(betaNode);
         return node;
       }
     }
 
-    private static ISymbolicExpressionTreeNode MakeConstant(double c) {
-      var node = (ConstantTreeNode)(new Constant()).CreateTreeNode();
+    private static ISymbolicExpressionTreeNode MakeNumber(double c) {
+      var node = (NumberTreeNode)(new Number()).CreateTreeNode();
       node.Value = c;
       return node;
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisModelComplexityCalculator.cs	(revision 18132)
@@ -36,4 +36,5 @@
 
       switch (OpCodes.MapSymbolToOpCode(node)) {
+        case OpCodes.Number: // fall through
         case OpCodes.Constant: {
             return 1;
@@ -80,5 +81,5 @@
         case OpCodes.Root: {
             double complexity = CalculateComplexity(node.GetSubtree(0));
-            var exponent = node.GetSubtree(1) as ConstantTreeNode;
+            var exponent = node.GetSubtree(1) as INumericTreeNode;
             if (exponent != null) {
               double expVal = exponent.Value;
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSolutionImpactValuesCalculator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSolutionImpactValuesCalculator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/SymbolicDataAnalysisSolutionImpactValuesCalculator.cs	(revision 18132)
@@ -59,6 +59,6 @@
         tempModelParentNode.RemoveSubtree(i);
 
-        var constantNode = new ConstantTreeNode(new Constant()) { Value = repValue };
-        tempModelParentNode.InsertSubtree(i, constantNode);
+        var numberNode = new NumberTreeNode(new Number()) { Value = repValue };
+        tempModelParentNode.InsertSubtree(i, numberNode);
 
         newQualityForImpactsCalculation = CalculateQualityForImpacts(tempModel, problemData, rows);
@@ -79,10 +79,9 @@
     protected IEnumerable<double> CalculateReplacementValues(ISymbolicExpressionTreeNode node, ISymbolicExpressionTree sourceTree, ISymbolicDataAnalysisExpressionTreeInterpreter interpreter,
       IDataset dataset, IEnumerable<int> rows) {
-      //optimization: constant nodes return always the same value
-      ConstantTreeNode constantNode = node as ConstantTreeNode;
+      var numberNode = node as INumericTreeNode;
       BinaryFactorVariableTreeNode binaryFactorNode = node as BinaryFactorVariableTreeNode;
       FactorVariableTreeNode factorNode = node as FactorVariableTreeNode;
-      if (constantNode != null) {
-        yield return constantNode.Value;
+      if (numberNode != null) {
+        yield return numberNode.Value;
       } else if (binaryFactorNode != null) {
         // valid replacements are either all off or all on
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Constant.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Constant.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Constant.cs	(revision 18132)
@@ -1,3 +1,3 @@
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -20,109 +20,36 @@
 #endregion
 
-using System;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HEAL.Attic;
+
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  [StorableType("5CD355EA-36E4-4E43-B8C4-9E9CF4CBC860")]
-  [Item("Constant", "Represents a constant value.")]
-  public sealed class Constant : Symbol {
-    #region Properties
-    [Storable]
-    private double minValue;
-    public double MinValue {
-      get { return minValue; }
-      set {
-        if (value != minValue) {
-          minValue = value;
-          OnChanged(EventArgs.Empty);
-        }
-      }
-    }
-    [Storable]
-    private double maxValue;
-    public double MaxValue {
-      get { return maxValue; }
-      set {
-        if (value != maxValue) {
-          maxValue = value;
-          OnChanged(EventArgs.Empty);
-        }
-      }
-    }
-    [Storable]
-    private double manipulatorMu;
-    public double ManipulatorMu {
-      get { return manipulatorMu; }
-      set {
-        if (value != manipulatorMu) {
-          manipulatorMu = value;
-          OnChanged(EventArgs.Empty);
-        }
-      }
-    }
-    [Storable]
-    private double manipulatorSigma;
-    public double ManipulatorSigma {
-      get { return manipulatorSigma; }
-      set {
-        if (value < 0) throw new ArgumentException();
-        if (value != manipulatorSigma) {
-          manipulatorSigma = value;
-          OnChanged(EventArgs.Empty);
-        }
-      }
-    }
-    [Storable(DefaultValue = 0.0)]
-    private double multiplicativeManipulatorSigma;
-    public double MultiplicativeManipulatorSigma {
-      get { return multiplicativeManipulatorSigma; }
-      set {
-        if (value < 0) throw new ArgumentException();
-        if (value != multiplicativeManipulatorSigma) {
-          multiplicativeManipulatorSigma = value;
-          OnChanged(EventArgs.Empty);
-        }
-      }
-    }
-
+  [StorableType("44E03792-5E65-4C70-99B2-7849B8927E28")]
+  [Item("Constant", "Represents a real-valued constant.")]
+  public sealed class Constant : Symbol, INumericSymbol {
     private const int minimumArity = 0;
     private const int maximumArity = 0;
 
-    public override int MinimumArity {
-      get { return minimumArity; }
-    }
-    public override int MaximumArity {
-      get { return maximumArity; }
-    }
-    #endregion
+    public override int MinimumArity => minimumArity;
+    public override int MaximumArity => maximumArity;
+
+    public double Value { get; set; }
 
     [StorableConstructor]
     private Constant(StorableConstructorFlag _) : base(_) { }
-    private Constant(Constant original, Cloner cloner)
-      : base(original, cloner) {
-      minValue = original.minValue;
-      maxValue = original.maxValue;
-      manipulatorMu = original.manipulatorMu;
-      manipulatorSigma = original.manipulatorSigma;
-      multiplicativeManipulatorSigma = original.multiplicativeManipulatorSigma;
+
+    private Constant(Constant original, Cloner cloner) : base(original, cloner) {
+      this.Value = original.Value;
     }
-    public Constant()
-      : base("Constant", "Represents a constant value.") {
-      manipulatorMu = 0.0;
-      manipulatorSigma = 1.0;
-      multiplicativeManipulatorSigma = 0.03;
-      minValue = -20.0;
-      maxValue = 20.0;
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Constant(this, cloner);
     }
+
+    public Constant() : base("Constant", "Represents a real-valued constant.") { }
 
     public override ISymbolicExpressionTreeNode CreateTreeNode() {
       return new ConstantTreeNode(this);
     }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new Constant(this, cloner);
-    }
   }
 }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ConstantTreeNode.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ConstantTreeNode.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/ConstantTreeNode.cs	(revision 18132)
@@ -1,3 +1,3 @@
-#region License Information
+﻿#region License Information
 /* HeuristicLab
  * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
@@ -20,21 +20,17 @@
 #endregion
 
+using HEAL.Attic;
 using HeuristicLab.Common;
-using HeuristicLab.Core;
 using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
-using HEAL.Attic;
-using HeuristicLab.Random;
+
 namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
-  [StorableType("247DBD04-18F2-4184-B6F5-6E283BF06FD0")]
-  public sealed class ConstantTreeNode : SymbolicExpressionTreeTerminalNode {
-    public new Constant Symbol {
-      get { return (Constant)base.Symbol; }
-    }
+  [StorableType("F91000E6-B041-4648-A9E8-595228F957FA")]
+  public sealed class ConstantTreeNode : SymbolicExpressionTreeTerminalNode, INumericTreeNode {
 
-    private double constantValue;
-    [Storable]
-    public double Value {
-      get { return constantValue; }
-      set { constantValue = value; }
+    public new Constant Symbol => (Constant) base.Symbol;
+
+    public double Value { 
+      get => Symbol.Value;
+      set => throw new System.NotSupportedException("Cannot change the value of a constant.");
     }
 
@@ -44,32 +40,8 @@
     private ConstantTreeNode(ConstantTreeNode original, Cloner cloner)
       : base(original, cloner) {
-      constantValue = original.constantValue;
     }
 
     private ConstantTreeNode() : base() { }
     public ConstantTreeNode(Constant constantSymbol) : base(constantSymbol) { }
-
-    public override bool HasLocalParameters {
-      get {
-        return true;
-      }
-    }
-    public override void ResetLocalParameters(IRandom random) {
-      base.ResetLocalParameters(random);
-      var range = Symbol.MaxValue - Symbol.MinValue;
-      Value = random.NextDouble() * range + Symbol.MinValue;
-    }
-
-    public override void ShakeLocalParameters(IRandom random, double shakingFactor) {
-      base.ShakeLocalParameters(random, shakingFactor);
-      // 50% additive & 50% multiplicative
-      if (random.NextDouble() < 0.5) {
-        double x = NormalDistributedRandom.NextDouble(random, Symbol.ManipulatorMu, Symbol.ManipulatorSigma);
-        Value = Value + x * shakingFactor;
-      } else {
-        double x = NormalDistributedRandom.NextDouble(random, 1.0, Symbol.MultiplicativeManipulatorSigma);
-        Value = Value * x;
-      }
-    }
 
     public override IDeepCloneable Clone(Cloner cloner) {
@@ -78,5 +50,5 @@
 
     public override string ToString() {
-      return constantValue.ToString("E4");
+      return $"{Value:E4}";
     }
   }
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Number.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Number.cs	(revision 18132)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/Number.cs	(revision 18132)
@@ -0,0 +1,128 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HEAL.Attic;
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("5CD355EA-36E4-4E43-B8C4-9E9CF4CBC860")]
+  [Item("Number", "Represents a number.")]
+  public sealed class Number : Symbol, INumericSymbol {
+    #region Properties
+    [Storable]
+    private double minValue;
+    public double MinValue {
+      get { return minValue; }
+      set {
+        if (value != minValue) {
+          minValue = value;
+          OnChanged(EventArgs.Empty);
+        }
+      }
+    }
+    [Storable]
+    private double maxValue;
+    public double MaxValue {
+      get { return maxValue; }
+      set {
+        if (value != maxValue) {
+          maxValue = value;
+          OnChanged(EventArgs.Empty);
+        }
+      }
+    }
+    [Storable]
+    private double manipulatorMu;
+    public double ManipulatorMu {
+      get { return manipulatorMu; }
+      set {
+        if (value != manipulatorMu) {
+          manipulatorMu = value;
+          OnChanged(EventArgs.Empty);
+        }
+      }
+    }
+    [Storable]
+    private double manipulatorSigma;
+    public double ManipulatorSigma {
+      get { return manipulatorSigma; }
+      set {
+        if (value < 0) throw new ArgumentException();
+        if (value != manipulatorSigma) {
+          manipulatorSigma = value;
+          OnChanged(EventArgs.Empty);
+        }
+      }
+    }
+    [Storable(DefaultValue = 0.0)]
+    private double multiplicativeManipulatorSigma;
+    public double MultiplicativeManipulatorSigma {
+      get { return multiplicativeManipulatorSigma; }
+      set {
+        if (value < 0) throw new ArgumentException();
+        if (value != multiplicativeManipulatorSigma) {
+          multiplicativeManipulatorSigma = value;
+          OnChanged(EventArgs.Empty);
+        }
+      }
+    }
+
+    private const int minimumArity = 0;
+    private const int maximumArity = 0;
+
+    public override int MinimumArity {
+      get { return minimumArity; }
+    }
+    public override int MaximumArity {
+      get { return maximumArity; }
+    }
+    #endregion
+
+    [StorableConstructor]
+    private Number(StorableConstructorFlag _) : base(_) { }
+    private Number(Number original, Cloner cloner)
+      : base(original, cloner) {
+      minValue = original.minValue;
+      maxValue = original.maxValue;
+      manipulatorMu = original.manipulatorMu;
+      manipulatorSigma = original.manipulatorSigma;
+      multiplicativeManipulatorSigma = original.multiplicativeManipulatorSigma;
+    }
+    public Number()
+      : base("Number", "Represents a numerical value.") {
+      manipulatorMu = 0.0;
+      manipulatorSigma = 1.0;
+      multiplicativeManipulatorSigma = 0.03;
+      minValue = -20.0;
+      maxValue = 20.0;
+    }
+
+    public override ISymbolicExpressionTreeNode CreateTreeNode() {
+      return new NumberTreeNode(this);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new Number(this, cloner);
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/NumberTreeNode.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/NumberTreeNode.cs	(revision 18132)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Symbols/NumberTreeNode.cs	(revision 18132)
@@ -0,0 +1,74 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
+using HEAL.Attic;
+using HeuristicLab.Random;
+namespace HeuristicLab.Problems.DataAnalysis.Symbolic {
+  [StorableType("247DBD04-18F2-4184-B6F5-6E283BF06FD0")]
+  public sealed class NumberTreeNode : SymbolicExpressionTreeTerminalNode, INumericTreeNode {
+    public new Number Symbol => (Number)base.Symbol;
+
+    [Storable]
+    public double Value { get; set; }
+
+    [StorableConstructor]
+    private NumberTreeNode(StorableConstructorFlag _) : base(_) { }
+
+    private NumberTreeNode(NumberTreeNode original, Cloner cloner)
+      : base(original, cloner) {
+      Value = original.Value;
+    }
+
+    private NumberTreeNode() : base() { }
+    public NumberTreeNode(Number numberSymbol) : base(numberSymbol) { }
+
+    public override bool HasLocalParameters => true;
+
+    public override void ResetLocalParameters(IRandom random) {
+      base.ResetLocalParameters(random);
+      var range = Symbol.MaxValue - Symbol.MinValue;
+      Value = random.NextDouble() * range + Symbol.MinValue;
+    }
+
+    public override void ShakeLocalParameters(IRandom random, double shakingFactor) {
+      base.ShakeLocalParameters(random, shakingFactor);
+      // 50% additive & 50% multiplicative
+      if (random.NextDouble() < 0.5) {
+        var x = NormalDistributedRandom.NextDouble(random, Symbol.ManipulatorMu, Symbol.ManipulatorSigma);
+        Value = Value + x * shakingFactor;
+      } else {
+        var x = NormalDistributedRandom.NextDouble(random, 1.0, Symbol.MultiplicativeManipulatorSigma);
+        Value = Value * x;
+      }
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new NumberTreeNode(this, cloner);
+    }
+
+    public override string ToString() {
+      return $"{Value:E4}";
+    }
+  }
+}
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/SymbolicExpressionTreeBacktransformator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/SymbolicExpressionTreeBacktransformator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/SymbolicExpressionTreeBacktransformator.cs	(revision 18132)
@@ -90,5 +90,5 @@
     private ISymbolicExpressionTreeNode CreateNodeFromWeight(ISymbolicExpressionTreeNode transformationTree, VariableTreeNode variableNode) {
       var multiplicationNode = new SymbolicExpressionTreeNode(new Multiplication());
-      multiplicationNode.AddSubtree(new ConstantTreeNode(new Constant()) { Value = variableNode.Weight });
+      multiplicationNode.AddSubtree(new NumberTreeNode(new Number()) { Value = variableNode.Weight });
       multiplicationNode.AddSubtree(transformationTree);
       return multiplicationNode;
